Public Class Employee

    Private strFName As String
    Private strLName As String
    Private intEmployeeId As Integer

    Public Property FirstName() As String
        Get
            Return strFName
        End Get
        Set(ByVal Value As String)
            strFName = Value
        End Set
    End Property

    Public Property LastName() As String
        Get
            Return strLName
        End Get
        Set(ByVal Value As String)
            strLName = Value
        End Set
    End Property

    Public ReadOnly Property EmployeeId() As Integer
        Get
            Return intEmployeeId
        End Get
    End Property

    Public Sub Save()
        'save the details to the database    
    End Sub

    Public Sub New()
        'hard coded value to simulate database retrieval
        intEmployeeId = 20
    End Sub

    Public Sub New(ByVal intEmpID As Integer)
        'hard coded values to simulate database retrieval
        intEmployeeId = EmployeeId
        FirstName = "Joe"
        LastName = "Howard"
    End Sub

    Public Sub New(ByVal strFirstName As String, ByVal strLastName As String)
        'used to create a new employee, and intialize the first and last names
        FirstName = strFirstName
        LastName = strLastName
        intEmployeeId = 21        'taken from database counter
    End Sub


    Protected Overrides Sub Finalize()
        'important to note when this method fires
        Debug.WriteLine("Finalize")
        Dispose()       'call the Dispose method to clean up resources
        MyBase.Finalize()
    End Sub

    Public Sub Dispose()
        'save changes and close database connection etc.
        'connection.Close() 
        Debug.WriteLine("Dispose")
    End Sub

End Class
