Public Class Employee

    'event declaration that allows cancellation of update
    Public Event DataChanged(ByVal PropertyName As String, ByRef Cancelled As Boolean)



    Private strFName As String
    Private strLName As String
    Private intEmployeeID As Integer

    Public Property FirstName() As String
        Get
            Return strFName
        End Get
        Set(ByVal Value As String)
            Dim blnCancelled As Boolean, strTemp As String = strFName
            strFName = Value

            'if someone changes the FirstName property, raise the event
            RaiseEvent DataChanged("FirstName", blnCancelled)

            'check the value of the vFlag and reset the value if cancel was requested
            If blnCancelled = True Then
                strFName = strTemp
            End If
        End Set
    End Property

    Public Property LastName() As String
        Get
            Return strLName
        End Get
        Set(ByVal Value As String)
            Dim blnCancelled As Boolean, strTemp As String = strLName
            strLName = Value

            'if someone changes the FirstName property, raise the event            
            RaiseEvent DataChanged("LastName", blnCancelled)

            'check the value of the vFlag and reset the value if cancel was requested
            If blnCancelled = True Then
                strLName = strTemp
            End If
        End Set
    End Property

    Public ReadOnly Property EmployeeId() As Integer
        Get
            Return intEmployeeID
        End Get
    End Property

End Class
