Public Class Employee
    Implements IPerson

    Private intEmployeeID As Integer
    Private strFName As String
    Private strLName As String

    'unique property to Employee
    Public Property EmployeeId() As Integer
        Get
            Return intEmployeeID
        End Get
        Set(ByVal Value As Integer)
            intEmployeeID = Value
        End Set
    End Property

    'private declaration means IPerson interface must be used to access this member
    'if public was used, the member would be accessible via the interface and the class
    Private Property FirstName() As String Implements IPerson.FirstName
        Get
            Return strFName
        End Get
        Set(ByVal Value As String)
            strFName = Value
        End Set
    End Property

    'private declaration means IPerson interface must be used to access this member
    'if public was used, the member would be accessible via the interface and the class
    Private Property LastName() As String Implements IPerson.LastName
        Get
            Return strLName
        End Get
        Set(ByVal Value As String)
            strLName = Value
        End Set
    End Property

    'public declaration means Save member is accessible via the IPerson interface 
    'and the SaveEmployee member of the Employee class
    Public Sub SaveEmployee() Implements IPerson.Save
        MsgBox(FirstName & " " & LastName, , "Saving Employee " & EmployeeId)
    End Sub

End Class
