Public Class Student
    Implements IPerson

    Private strCourse As String
    Private strFName As String
    Private strLName As String

    'unique property to Student
    Public Property Course() As String
        Get
            Return strCourse
        End Get
        Set(ByVal Value As String)
            strCourse = Value
        End Set
    End Property

    'private declaration means IPerson interface must be used to access this member
    'if public was used, the member would be accessible via the interface and the class
    Private Property FirstName() As String Implements IPerson.FirstName
        Get
            Return strFName
        End Get
        Set(ByVal Value As String)
            strFName = Value
        End Set
    End Property

    'private declaration means IPerson interface must be used to access this member
    'if public was used, the member would be accessible via the interface and the class
    Private Property LastName() As String Implements IPerson.LastName
        Get
            Return strLName
        End Get
        Set(ByVal Value As String)
            strLName = Value
        End Set
    End Property

    'public declaration means Save member is accessible via both the IPerson interface 
    'and the Student class
    Public Sub Save() Implements IPerson.Save
        MsgBox(FirstName & " " & LastName, , "Saving Student " & Course)
    End Sub

End Class
