Public Class Employee
    Inherits Person     'inherit the Person class    
    Private intEmployeeID As Integer

    Public ReadOnly Property EmployeeId() As Integer
        Get
            Return intEmployeeID
        End Get
    End Property

    Public Sub New(ByVal EmployeeId As Integer)
        'used to retrieve details from database
        'hardcoded for demonstration only
        intEmployeeID = EmployeeId
        FirstName = "Joe"
        LastName = "Howard"
    End Sub

    Public Overloads Sub Dispose()
        'Make sure database connection is closed etc.
        'connection.Close()
        MyBase.Dispose()        'use MyBase to call dispose method of base class
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

    Public Overloads Sub Save(ByVal i As Integer)
        'save the details to the database    
    End Sub

End Class
